<%@ taglib prefix="cs" uri="futuretense_cs/ftcs1_0.tld" %>
<%@ taglib prefix="ics" uri="futuretense_cs/ics.tld" %>
<%@ taglib prefix="satellite" uri="futuretense_cs/satellite.tld" %>
<%//
// fatwire/dash/attributerenderers/htmltextdataRenderer
//
// INPUT
//
// OUTPUT
//%>
<%@ page import="COM.FutureTense.Interfaces.FTValList" %>
<%@ page import="COM.FutureTense.Interfaces.ICS" %>
<%@ page import="COM.FutureTense.Interfaces.IList" %>
<%@ page import="COM.FutureTense.Interfaces.Utilities" %>
<%@ page import="COM.FutureTense.Util.ftErrors" %>
<%@ page import="COM.FutureTense.Util.ftMessage"%>
<%@ page import="javax.faces.context.ResponseWriter"%>
<%@ page import="com.fatwire.cs.ui.view.renderer.RenderDataContext"%>
<%@ page import="com.fatwire.cs.ui.view.renderer.RenderConstants"%>
<%@ page import="java.util.List"%>
<%@ page import="java.util.Map"%>
<%@ page import="com.fatwire.assetapi.def.AttributeDef"%>
<%@ page import="com.fatwire.assetapi.def.AttributeTypeEnum"%>
<%@ page import="com.fatwire.assetapi.data.AttributeData"%>
<%@ page import="com.fatwire.cs.ui.model.bo.asset.AttributeEditor"%>
<%@ page import="com.fatwire.cs.ui.model.bo.asset.Asset"%>
<%@ page import="com.fatwire.cs.ui.view.renderer.AssetRenderUtil"%>
<%@ page import="javax.faces.component.UIComponent"%>
<%@ page import="com.fatwire.cs.ui.view.backing.GenericUtil"%>


<cs:ftcs>

<%
	ResponseWriter writer =(ResponseWriter ) request.getAttribute("writer");
	String mode = (String ) request.getAttribute("mode");	
	UIComponent component = (UIComponent ) request.getAttribute("component");
	RenderDataContext renderContext =(RenderDataContext ) request.getAttribute("renderdatacontext");
	String id =  generateID(renderContext , 0);	 
	
	if("paint".equals(mode))
	{
		AttributeDef def = renderContext.getAttributeDef ();
		AttributeEditor editor = renderContext.getEditor ();
		int xsz = GenericUtil.getValidInt((String)editor.getProperty(RenderConstants.TEXTFIELD.XSIZE));
        if(-1 == xsz)
        {
            xsz = 97;
        }		
		String toolTip = (String)editor.getProperty(RenderConstants.INSTRUCTION);
        		String label = AssetRenderUtil.getLabelText(renderContext.getLabel());
		String labelStyle = renderContext.getLabelStyle();
		List data = renderContext.getAttributeData().getDataAsList();
		String value = data.size() > 0 ? data.get(0).toString() : "";		
				
		StringBuilder ouput = new StringBuilder();
		// Build a row for displaying the attribute
		ouput.append("<tr><td>");
		ouput.append("<table><tr><td>");
		ouput.append("<table align='left' class='"+labelStyle+"'><tr><td>");
		ouput.append(label);
		ouput.append("</td></tr></table>");
		ouput.append("</td></tr>");
		ouput.append("<tr><td>");
		ouput.append("<table align='left'><tr><td>");
		ouput.append("<input type='text' class='AFFieldText' value='"+value+"' name='"+id+"' size='"+xsz+"'><tr><td>");		
		ouput.append("</td></tr></table>");
		ouput.append("</td></tr>");
		ouput.append("<tr><td>");		
		ouput.append("</td></tr>");

		ouput.append("</table></td>");
		ouput.append("</tr>");		
		writer.write(ouput.toString());
		
		
		
		
	} 
	else if("update".equals(mode))
	{
	//Update the attribute data by reading from the request parameter map
			Map requestMap = (Map ) request.getAttribute("requestParameterMap");			
			List data = renderContext.getAttributeData().getDataAsList();
			if (requestMap.containsKey(id))
			{
				String text = ((String) requestMap.get(id)).trim();	
					if(data.isEmpty ())
					{
						data.add("") ;
					}
				data.set(0,text);
			}	
	}

%>

<%!

	 
	 private String generateID(RenderDataContext context , int index)
    {
       return formatId((new StringBuilder()).append("INPUT_").append(context.getTabName()).append("_")
                                                             .append(context.getLocale()).append("_")
                                                             .append(context.getAttributeName()).append("_")
                                                             .append(context.isMetaAttribute()).append("_")
                                                             .append(context.getAttributeIndex())                                                             
                                                             .append("_").append(index).toString());
    }

	
	private String formatId(String input)
    {
        // Add underscore for the id.Because ADF does not like the id to start with numbers
        input = "_" + input;
        if(input != null)
        {
            return input.replaceAll("\\W", "_");
        }
        return "";
    }
    
	
%>

</cs:ftcs>