<%@ taglib prefix="cs" uri="futuretense_cs/ftcs1_0.tld" %>
<%@ taglib prefix="ics" uri="futuretense_cs/ics.tld" %>
<%@ taglib prefix="satellite" uri="futuretense_cs/satellite.tld" %>
<%//
// fatwire/dash/attributerenderers/multiValuedTextRenderer
//
// INPUT
//
// OUTPUT
//%>

<%@ page import="COM.FutureTense.Interfaces.FTValList" %>
<%@ page import="COM.FutureTense.Interfaces.ICS" %>
<%@ page import="COM.FutureTense.Interfaces.IList" %>
<%@ page import="COM.FutureTense.Interfaces.Utilities" %>
<%@ page import="COM.FutureTense.Util.ftErrors" %>
<%@ page import="COM.FutureTense.Util.ftMessage"%>
<%@ page import="javax.faces.context.ResponseWriter"%>
<%@ page import="com.fatwire.cs.ui.view.renderer.RenderDataContext"%>
<%@ page import="com.fatwire.cs.ui.view.renderer.RenderConstants"%>
<%@ page import="java.util.List"%>
<%@ page import="java.util.Map"%>
<%@ page import="com.fatwire.assetapi.def.AttributeDef"%>
<%@ page import="com.fatwire.assetapi.def.AttributeTypeEnum"%>
<%@ page import="com.fatwire.assetapi.data.AttributeData"%>
<%@ page import="com.fatwire.cs.ui.model.bo.asset.AttributeEditor"%>
<%@ page import="com.fatwire.cs.ui.model.bo.asset.Asset"%>
<%@ page import="com.fatwire.cs.ui.view.renderer.AssetRenderUtil"%>
<%@ page import="javax.faces.component.UIComponent"%>
<%@ page import="java.util.StringTokenizer"%>
<%@ page import="com.fatwire.cs.ui.view.util.FacesUtils"%>
<%@ page import="com.fatwire.cs.ui.view.constant.ViewConstants"%>
<%@ page import="com.fatwire.cs.ui.view.constant.BeanNames"%>
<%@ page import="com.fatwire.assetapi.def.AttributeDefProperties.ValueCount"%>
<%@ page import="java.io.IOException"%>
<%@ page import="javax.faces.context.FacesContext"%>

<cs:ftcs>

<%
	ResponseWriter writer =(ResponseWriter ) request.getAttribute("writer");
	String mode = (String ) request.getAttribute("mode");	
	UIComponent component = (UIComponent ) request.getAttribute("component");
	RenderDataContext renderContext =(RenderDataContext ) request.getAttribute("renderdatacontext");
	String uniqueId = generateID(renderContext);	 	 
	
	if("paint".equals(mode))
	{
		AttributeDef def = renderContext.getAttributeDef ();
		AttributeEditor editor = renderContext.getEditor ();		
		String toolTip = (String)editor.getProperty(RenderConstants.INSTRUCTION);
        		String label = AssetRenderUtil.getLabelText(renderContext.getLabel());
		String labelStyle = renderContext.getLabelStyle();
		List data = renderContext.getAttributeData().getDataAsList();
		ValueCount valueCount = def.getProperties().getValueCount();
		if(data.isEmpty())
		{
			data.add("");
		}
		int size = data.size();		
		// include the javascript file
		renderScriptOnce(writer, component);
		StringBuilder ouput = new StringBuilder();
		// Build a row for displaying the attribute	
		

		
                       ouput.append("<tr><td>");
		ouput.append("<table><tr><td>");
		ouput.append("<table align='left' class='"+labelStyle+"'><tr><td>");
		ouput.append(label);
		ouput.append("</td></tr></table>");
		ouput.append("</td></tr>");	
		ouput.append("<tr><td><table id=\""+uniqueId+"_controlstable\">");
		ouput.append("<tbody id=\""+uniqueId+"_controlstablebody\">");
		int counter = 1;
		String indices = "1";
		ViewConstants viewConstants = (ViewConstants) FacesUtils.getManagedBean (BeanNames.BACKING_VIEWCONSTANTS);
		String up = ViewConstants.IMAGE_DIR +"/up.gif";
		String upHover = ViewConstants.IMAGE_DIR +"/uphover.gif";
		String down = ViewConstants.IMAGE_DIR +"/down.gif";
		String downHover = ViewConstants.IMAGE_DIR +"/downhover.gif";
		String delete = ViewConstants.IMAGE_DIR +"/delete.gif";
		String deleteHover = ViewConstants.IMAGE_DIR +"/deletehover.gif";
		String addNew = viewConstants.getLocalizedImageDir () +"/addnew.gif";
		String addNewHover = viewConstants.getLocalizedImageDir () +"/addnewBlue.gif";
		
	    for(Object value: data)
		{
			ouput.append("<tr id=\""+uniqueId+"_controlsrow_"+counter+"\">");
			ouput.append("<td><input type=\"text\" class='AFFieldText' name=\""+uniqueId+"_input_"+counter+"\" id=\""+uniqueId+"_input_"+counter+"\" value=\""+value.toString()+"\" size=\"97\"></td>");
			ouput.append("<td>");
			ouput.append("<table>");
			ouput.append("<tbody id=\""+uniqueId+"_buttonstable_"+counter+"\">");
			ouput.append("<tr>");
			ouput.append("<td>");
			ouput.append("<img src='"+up+"' onmouseover=\"swap(this,'"+upHover+"')\" onmouseout=\"swap(this,'"+up+"')\" id=\""+uniqueId+"_upbutton_"+counter+"\" ");
			if(counter == 1)
			{
				ouput.append("style=\"display: none\" ");
			}	
			ouput.append(" onclick=\"moveUp('"+uniqueId+"',"+counter+")\"></td>");
			ouput.append("<td>");
			ouput.append("<img src='"+down+"' onmouseover=\"swap(this,'"+downHover+"')\" onmouseout=\"swap(this,'"+down+"')\" id=\""+uniqueId+"_downbutton_"+counter+"\" ");
			if(size == 1 ||  counter == size)
			{
				ouput.append("style=\"display: none\" ");
			}	
			ouput.append(" onclick=\"moveDown('"+uniqueId+"',"+counter+")\"></td>");
			ouput.append("<td>");
			ouput.append("<img src='"+delete+"' onmouseover=\"swap(this,'"+deleteHover+"')\" onmouseout=\"swap(this,'"+delete+"')\" id=\""+uniqueId+"_deletebutton_"+counter+"\" ");			
			if(size == 1)
			{
				ouput.append("style=\"display: none\" ");
			}
			ouput.append(" onclick=\"removeRow('"+uniqueId+"',"+counter+")\"></td>");
			ouput.append("</tr>");
			ouput.append("</tbody>");
			ouput.append("</table>");
			ouput.append("</td>");
			ouput.append("</tr>");
			if(counter > 1)
			{
				indices = indices +"," + counter;
			}
			counter ++;
		}
		ouput.append("</tbody></table></td></tr>");
		if(valueCount == ValueCount.MULTI || valueCount ==  ValueCount.MULTI_ORDERED)
		{
			ouput.append("<tr><td><table id=\""+uniqueId+"_addnewTable\">");
			ouput.append("<tr><td>");
			
			ouput.append("<img src='"+addNew+"' onmouseover=\"swap(this,'"+addNewHover+"')\" onmouseout=\"swap(this,'"+addNew+"')\" onclick=\"addnewRow('"+uniqueId+"')\">");		
			ouput.append("<input type=\"hidden\" name=\""+uniqueId+"_hiddenindices\" id=\""+uniqueId+"_hiddenindices\" value=\""+indices+"\">	");		
			ouput.append("</td>");
			ouput.append("</tr>"); 
		}	
		ouput.append("</table></td></tr></table></td></tr>"); 
		writer.write(ouput.toString());
		
		
		
	} 
	else if("update".equals(mode))
	{
			Map requestMap = (Map ) request.getAttribute("requestParameterMap");	
			//Update the attribute data by reading from the request parameter map
			String hiddenIndices = ((String) requestMap.get(uniqueId+"_hiddenindices")).trim();		
            List data = renderContext.getAttributeData().getDataAsList();
			data.clear();
			StringTokenizer st = new StringTokenizer( hiddenIndices, ",");
			while (st.hasMoreTokens() )
            {
				String t = st.nextToken();
				String key = uniqueId +"_input_" + t;
				String text = (String) requestMap.get(key);					
				data.add(text);
			}
	}

%>

<%!
	 private String generateID(RenderDataContext context)
    {
       return formatId((new StringBuilder()).append("INPUT_").append(context.getTabName()).append("_")
                                                             .append(context.getLocale()).append("_")
                                                             .append(context.getAttributeName()).append("_")
                                                             .append(context.isMetaAttribute()).append("_")
                                                             .append(context.getAttributeIndex()).toString());
    }

	
	private String formatId(String input)
    {
        // Add underscore for the id.Because ADF does not like the id to start with numbers
        input = "_" + input;
        if(input != null)
        {
            return input.replaceAll("\\W", "_");
        }
        return "";
    }
    
	
	private void renderScriptOnce(ResponseWriter responsewriter, UIComponent uicomponent) throws IOException
    {
	    Map requestMap = FacesContext.getCurrentInstance ().getExternalContext ().getRequestMap ();
        Boolean loaded = (Boolean)requestMap.get("multivalued-script-rendered");
        if(loaded == Boolean.TRUE)
        {
            return;
        } else
        {
		requestMap.put("multivalued-script-rendered", Boolean.TRUE);
        responsewriter.startElement("script", uicomponent);
        responsewriter.writeAttribute("type", "text/javascript", null);
        String s1 = "faces/js/multivalued.js";
        responsewriter.writeAttribute("src", s1, null);
        responsewriter.endElement("script");
        responsewriter.write("\n");
        return;
        }
    }

	
%>

</cs:ftcs>